#include "cdialog_main.h"

//-   ----------------------------------------
BEGIN_MESSAGE_MAP(CDialog_Main,CDialog)
 ON_WM_DESTROY()
 ON_WM_CLOSE()
 ON_WM_PAINT()
 ON_WM_TIMER()
 ON_COMMAND(IDC_BUTTON_MAIN_SAVE_FRAME,OnButton_SaveFrame)
END_MESSAGE_MAP()
//- --------------------------------------------------------
CDialog_Main::CDialog_Main(LPCTSTR lpszTemplateName, CWnd* pParentWnd):CDialog(lpszTemplateName,pParentWnd)
{
 long n;
 ViewImagePtr=new unsigned long[IMAGE_WIDTH*IMAGE_HEIGHT];
 for(n=0;n<IMAGE_WIDTH*IMAGE_HEIGHT;n++) ViewImagePtr[n]=0;

 ColorImagePtr=new unsigned long[IMAGE_WIDTH*IMAGE_HEIGHT];
 for(n=0;n<IMAGE_WIDTH*IMAGE_HEIGHT;n++) ColorImagePtr[n]=0;

 ThermalImagePtr=new unsigned short[IMAGE_WIDTH*IMAGE_HEIGHT];
 for(n=0;n<IMAGE_WIDTH*IMAGE_HEIGHT;n++)ThermalImagePtr[n]=0;

 cWinThread_ProcessingThread=NULL;

 LastReceivedFrameIndex=0;

 sProtected.cFlirOneControl.LoadColorMap("iron.pal");// 

 PlanckR1=16528.178;
 PlanckB=1427.5;
 PlanckF=1.0;
 PlanckO=-1307.0;
 PlanckR2=0.012258549;

 TempReflected=20;
 Emissivity=0.95;
}
//- ---------------------------------------------------------
CDialog_Main::~CDialog_Main()
{
 delete[](ViewImagePtr);
 delete[](ColorImagePtr);
 delete[](ThermalImagePtr);
}
//-  -------------------------------------------------
afx_msg void CDialog_Main::OnOK(void)
{
}
afx_msg void CDialog_Main::OnCancel(void)
{
}
afx_msg void CDialog_Main::OnClose(void)
{
 EndDialog(0);
}
afx_msg BOOL CDialog_Main::OnInitDialog(void)
{
 ((CStatic *)GetDlgItem(IDC_STATIC_MAIN_TEMPER))->SetWindowText("");   
 StartThread();
 // 
 SetTimer(ID_TIMER_UPDATE,50,NULL);
 return(CDialog::OnInitDialog());
}
//-  ------------------------------------------------------
//-   ----------------------------------------
afx_msg void CDialog_Main::OnDestroy(void)
{
 KillTimer(ID_TIMER_UPDATE);
 StopThread();
 CDialog::OnDestroy();
}
afx_msg void CDialog_Main::OnTimer(UINT nIDEvent)
{
 if (nIDEvent==ID_TIMER_UPDATE) 
 {
  sProtected.cCriticalSection.Lock();
  // 
  unsigned long index;
  //  
  sProtected.cFlirOneControl.CopyThermalImage(ThermalImagePtr,THERMAL_IMAGE_SIZE_SHORT,index);
  //  
  sProtected.cFlirOneControl.CopyColorImage(ColorImagePtr,COLOR_IMAGE_SIZE_LONG,index);
  sProtected.cCriticalSection.Unlock();

  if (LastReceivedFrameIndex!=index)// 
  {
   memcpy(ViewImagePtr,ColorImagePtr,COLOR_IMAGE_SIZE_LONG*sizeof(unsigned long));

   //    
   char string[255];
   double t_max=-10000;
   double t_min=10000;
   double t=0;
   long point=0;// 
   unsigned short *t_ptr=ThermalImagePtr;
   unsigned long *c_ptr=ColorImagePtr;
   unsigned long *v_ptr=ViewImagePtr;
   for(long y=0;y<IMAGE_HEIGHT;y++)
   {
    for(long x=0;x<IMAGE_WIDTH;x++,t_ptr++,c_ptr++,v_ptr++)
	{
	 // 
     if (x==IMAGE_WIDTH/2-FRAME_SIZE || x==IMAGE_WIDTH/2+FRAME_SIZE)
	 {
      if (y>=IMAGE_HEIGHT/2-FRAME_SIZE && y<=IMAGE_HEIGHT/2+FRAME_SIZE) *v_ptr^=0x00FFFFFF;
	 }   
     if (y==IMAGE_HEIGHT/2-FRAME_SIZE || y==IMAGE_HEIGHT/2+FRAME_SIZE)
	 {
      if (x>=IMAGE_WIDTH/2-FRAME_SIZE && x<=IMAGE_WIDTH/2+FRAME_SIZE) *v_ptr^=0x00FFFFFF;
	 }   
	 //    ,  
     double pt;//  
	 if (GetTemperature(*t_ptr,pt)==false) continue;//  
	 if (pt>t_max) t_max=pt;
	 if (pt<t_min) t_min=pt;
	 if (x>=IMAGE_WIDTH/2-FRAME_SIZE && x<=IMAGE_WIDTH/2+FRAME_SIZE)
	 {
      if (y>=IMAGE_HEIGHT/2-FRAME_SIZE && y<=IMAGE_HEIGHT/2+FRAME_SIZE)
	  {
       point++;
	   t+=pt;
	  }
	 }
	}
   }
   if (point!=0)
   {
    t/=static_cast<double>(point);
    // 
    sprintf(string,"%.2f",t);
    ((CStatic *)GetDlgItem(IDC_STATIC_MAIN_TEMPER))->SetWindowText(string);   
   }
   else ((CStatic *)GetDlgItem(IDC_STATIC_MAIN_TEMPER))->SetWindowText("");   
   //  
   sprintf(string,"%.2f",t_min);
   ((CStatic *)GetDlgItem(IDC_STATIC_MAIN_TEMPER_MIN))->SetWindowText(string);   
   //  
   sprintf(string,"%.2f",t_max);
   ((CStatic *)GetDlgItem(IDC_STATIC_MAIN_TEMPER_MAX))->SetWindowText(string);   
  }
  LastReceivedFrameIndex=index;
  InvalidateRect(NULL,FALSE);
 }
 CDialog::OnTimer(nIDEvent);
}
afx_msg void CDialog_Main::OnPaint(void)
{
 CDialog::OnPaint();
 CPaintDC cPaintDC(((CStatic *)GetDlgItem(IDC_STATIC_MAIN)));

 CRect cRect;
 ((CStatic *)GetDlgItem(IDC_STATIC_MAIN))->GetClientRect(&cRect);
 //  
 long width=cRect.right-cRect.left;
 long height=cRect.bottom-cRect.top;
 
 if (width>height)
 {
  width=height*120/160;
 }
 else
 {
  height=width*160/120;
 }
 cRect.right=cRect.left+width;
 cRect.bottom=cRect.top+height;
 
 BITMAPINFOHEADER bmih;
 bmih.biSize=sizeof(BITMAPINFOHEADER);
 bmih.biWidth=IMAGE_WIDTH;
 bmih.biHeight=-IMAGE_HEIGHT;
 bmih.biPlanes=1;
 bmih.biBitCount=32;
 bmih.biCompression=BI_RGB;
 bmih.biSizeImage=0;
 bmih.biXPelsPerMeter=300;
 bmih.biYPelsPerMeter=300;
 bmih.biClrUsed=0;
 bmih.biClrImportant=0;
 RGBQUAD rgbq;
 BITMAPINFO info;
 rgbq.rgbBlue=1;
 rgbq.rgbGreen=0;
 rgbq.rgbRed=0;
 rgbq.rgbReserved=0;
 info.bmiHeader=bmih;
 info.bmiColors[0]=rgbq;

 StretchDIBits(cPaintDC,cRect.left,cRect.top,cRect.right-cRect.left,cRect.bottom-cRect.top,0,0,abs(bmih.biWidth),abs(bmih.biHeight),ViewImagePtr,&info,DIB_RGB_COLORS,SRCCOPY);
}
//---------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------
afx_msg void CDialog_Main::OnButton_SaveFrame(void)
{
 CreateDirectory("Image",NULL);
 //   
 time_t time_main=time(NULL);
 tm *tm_main=localtime(&time_main);
 //  
 char filename[1024];
 for(long index=1;index<1000;index++)	
 {
  sprintf(filename,"Image\\img[%04i.%02i.%02i %02i_%02i_%02i-%03ld].tga",tm_main->tm_year+1900,tm_main->tm_mon+1,tm_main->tm_mday,tm_main->tm_hour,tm_main->tm_min,tm_main->tm_sec,index);
  FILE *file=fopen(filename,"rb");
  if (file==NULL)//   
  {
   SaveTGA(filename,IMAGE_WIDTH,IMAGE_HEIGHT,reinterpret_cast<unsigned char*>(ColorImagePtr));
   break;
  }
  else fclose(file);     
 }	
}


//---------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------
void CDialog_Main::StartThread(void)
{
 StopThread();
 //  
 cEvent_Exit.ResetEvent();
 cWinThread_ProcessingThread=AfxBeginThread((AFX_THREADPROC)ProcessingThread,this);
 cWinThread_ProcessingThread->m_bAutoDelete=FALSE;
 SetThreadPriority(cWinThread_ProcessingThread->m_hThread,THREAD_PRIORITY_TIME_CRITICAL);
}
//---------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------
void CDialog_Main::StopThread(void)
{
 //  
 if (cWinThread_ProcessingThread!=NULL)
 {
  cEvent_Exit.SetEvent();
  if (cWinThread_ProcessingThread->m_hThread) WaitForSingleObject(cWinThread_ProcessingThread->m_hThread,INFINITE);
  delete(cWinThread_ProcessingThread);
 }
 cWinThread_ProcessingThread=NULL;
}
//---------------------------------------------------------------------------
//     
//---------------------------------------------------------------------------
CEvent* CDialog_Main::GetEventExitPtr(void)
{
 return(&cEvent_Exit);
}
//---------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------
bool CDialog_Main::Processing(void)
{
 bool ret;
 sProtected.cCriticalSection.Lock();
 ret=sProtected.cFlirOneControl.Processing();
 if (ret==false) sProtected.cFlirOneControl.Open();
 sProtected.cCriticalSection.Unlock();
 return(ret);
}
//---------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------
bool CDialog_Main::GetTemperature(unsigned short raw14,double &value)
{
 if (raw14>0x10000) return(false);
 raw14*=4;    
 double zn=(PlanckR2*(exp(PlanckB/(TempReflected+273.15))-PlanckF));
 if (fabs(zn)<EPS) return(false);
 double RAWrefl=PlanckR1/zn-PlanckO;
 double RAWobj=(raw14-(1-Emissivity)*RAWrefl)/Emissivity;
 double lgr=PlanckR1/(PlanckR2*(RAWobj+PlanckO)+PlanckF);
 if (lgr<=EPS) return(false);
 value=PlanckB/log(lgr)-273.15; 
 return(true);
}

//-  ------------------------------------------------------


//---------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------
UINT ProcessingThread(LPVOID pParam)
{
 unsigned long delay=0;
 timeBeginPeriod(1); 
 CDialog_Main *cDialog_Main_Ptr=reinterpret_cast<CDialog_Main *>(pParam);
 CEvent *cEvent_Exit_Ptr=cDialog_Main_Ptr->GetEventExitPtr();
 while(1)
 {
  if (WaitForSingleObject(cEvent_Exit_Ptr->m_hObject,delay)==WAIT_OBJECT_0) break;// 
  delay=1;
  if (cDialog_Main_Ptr->Processing()==false) delay=1000;
 }
 timeEndPeriod(1);
 return(0);
}


